//*******************************************************************************
//* Dieses Programm wurde von Ulrich Radig fr Atmel AVR C geschrieben  		*
//* 																			*
//* Ich wnsche jeden viel Spa mit diesen kleinen Web-Server der ohne 			*
//* zustzlichen Speicher auskommt.												*
//*																				*
//* Bei Fragen und Verbesserungen wendet euch per EMail an						*
//*																				*
//* mail@ulrichradig.de															*
//*																				*
//* oder im Forum meiner Web Page : www.ulrichradig.de							*
//*																				*
//*******************************************************************************

//Prototype
void ARP_Reply (char *,int *);
char IfArp (char *);

//Aufbau eines ARP Header
//	
//	2 BYTE Hardware Typ				|	2 BYTE Protokoll Typ	
//	1 BYTE Lnge Hardwareadresse	|	1 BYTE Lnge Protokolladresse
//	2 BYTE Operation
//	6 BYTE MAC Adresse Absender		|	4 BYTE IP Adresse Absender
//	6 BYTE MAC Adresse Empfnger	|	4 BYTE IP Adresse Empfnger	

//ARP Layout
#define	ARP_HWTYPE			  	0x0E	//Hardware Typ enthlt den Code fr Ethernet oder andere Link Layer
#define	ARP_PRTYPE				0x10	//Protokoll Typ enthlt den Code fr IP o. anderes bertragungsprotokoll
#define	ARP_HWLEN			  	0x12	//Lnge der Hardwareadresse enthlt 6 fr 6 Byte lange MAC Adressen
#define	ARP_PRLEN			  	0x13	//Lnge der Protocolladresse enthlt 4 fr 4 Byte lange IP Adressen
#define	ARP_OP				  	0x14	//Enthlt Code der signalisiert ob es sich um eine Anfrage o. Antwort handelt
#define	ARP_SHADDR			  	0x16	//Enthlt die MAC Adresse des Anfragenden   
#define	ARP_SIPADDR			  	0x1C	//Enthlt die IP Adresse des Absenders
#define	ARP_THADDR			  	0x20	//MAC Adresse Ziel, ist in diesem Fall 6 * 00,da die Adresse erst noch herausgefunden werden soll (ARP Request)  
#define	ARP_TIPADDR				0x26	//IP Adresse enthlt die IP Adresse zu der die Kommunikation aufgebaut werden soll 
