//*******************************************************************************
//* Dieses Programm wurde von Ulrich Radig fr Atmel AVR C geschrieben  		*
//* 																			*
//* Ich wnsche jeden viel Spa mit diesen kleinen Web-Server der ohne 			*
//* zustzlichen Speicher auskommt.												*
//*																				*
//* Bei Fragen und Verbesserungen wendet euch per EMail an						*
//*																				*
//* mail@ulrichradig.de															*
//*																				*
//* oder im Forum meiner Web Page : www.ulrichradig.de							*
//*																				*
//*******************************************************************************

//Prototype
int httpd (char*,int *);

#include <webpage.h>

int httpd (char* buffer,int *bufferlen)
{
	if (TCP_OPEN(buffer,bufferlen)==1)
		{
		return(0);
		}

	
	//Einlesen des TCP Socket
	unsigned int	TCP_Socket = (buffer[TCP_SRCPORT]<<8) + buffer[TCP_SRCPORT+1];
	char *Command = 0;
	char x = 0;
	*Command = x;
	
	for (int a=0;a<10;a++)
		{
		//berprft HTTP Header 
		if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 && TCP_Socket == TCP_Socket_Store[a] && TCP_Socket_Status[a] == 1)
			{
			//Errechnet startpunkt der Daten im Tcp buffer
			//IP Headerlnge + TCP Headerlnge + Ethernetframe
			unsigned int result16 = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;
			
			//Pointerold auf INDEX.HTM
			pointerold = Page1;
			
			Command = strstr(&buffer[result16],"ulrich.jpg");
			if (*Command != 0)
				{
				pointerold = Page2;
				}
				
			Command = strstr(&buffer[result16],"ulrich1.jpg");
			if (*Command != 0)
				{
				pointerold = Page2;
				}
			
			//Speichert Sequenzcounter und Aknowledgecounter
			tcp_store(buffer);		
			//Setzen des Ack Flag
			buffer[TCP_HDRFLAGS+1] |= ACK_FLAG;
			//erzeugt HTTP OK Packet
			tcp_add_data (HTTP_OK1,buffer,bufferlen);	
			//Erzeugt ein TCP Packet 
			tcp_make(buffer);			
			//Sendet das erzeugte TCP Packet 
			Write_Ethernet_Frame (buffer,*bufferlen);
			TCP_Socket_Status[a] = 2;
			TCP_Socket_Pointer[a] = pointerold;
			return(0);
			}
		}
		
	for (int a=0;a<10;a++)
		{
		if (TCP_Socket == TCP_Socket_Store[a] && TCP_Socket_Status[a] == 2)
			{
				buffer[TCP_HDRFLAGS+1] |= PSH_FLAG;
				//Speichert Sequenzcounter und Aknowledgecounter
				tcp_store(buffer);		
				//erzeugt Seiten Packet
				pointerold = TCP_Socket_Pointer[a];
				tcp_add_data (pointerold,buffer,bufferlen);
				TCP_Socket_Pointer[a] = pointerold;
				//Erzeugt ein TCP Packet 
				tcp_make(buffer);			
				//Sendet das erzeugte TCP Packet 
				Write_Ethernet_Frame (buffer,*bufferlen);	
				if (Sendpage == 0)
					{
					TCP_Socket_Status[a] = 3;
					}
				return (0);		
			}
		}
	//Diese Routine ffnet und schliet einen TCP Socket
	for (int a=0;a<10;a++)
		{
		if (TCP_Socket == TCP_Socket_Store[a] && TCP_Socket_Status[a] == 3)
			{
			TCP_Socket_Store[a] = 0;
			TCP_Socket_Status[a] = 0;
			printf("TCP Socket Close %d\n",TCP_Socket);
			TCP_PORT_CLOSE (buffer,bufferlen);
			break;
			}
		if (TCP_Socket == TCP_Socket_Store[a] && TCP_Socket_Status[a] == 0)
			{
			printf("TCP Socket Open %d\n",TCP_Socket);
			TCP_Socket_Status[a] = 1;
			break;
			}	
		}
return (0);
}


