//*******************************************************************************
//* Dieses Programm wurde von Ulrich Radig fr Atmel AVR C geschrieben  		*
//* 																			*
//* Ich wnsche jeden viel Spa mit diesen kleinen Web-Server der ohne 			*
//* zustzlichen Speicher auskommt.												*
//*																				*
//* Bei Fragen und Verbesserungen wendet euch per EMail an						*
//*																				*
//* mail@ulrichradig.de															*
//*																				*
//* oder im Forum meiner Web Page : www.ulrichradig.de							*
//*																				*
//*******************************************************************************

//Prototype
void tcp_store (char *);
void tcp_add_data (PGM_P ,char *,int *);
void TCP_New_Packtlen (char *buffer,int *bufferlen,int result16);
void tcp_make (char *);
void TCP_PORT_CLOSE (char *,int *);
int TCP_OPEN (char *,int *);

//Globale Variablen
unsigned char Sendpage = 2;
unsigned int TCP_Socket_Store[10] = {0,0,0,0,0,0,0,0,0,0};
unsigned int TCP_Socket_Status[10] = {0,0,0,0,0,0,0,0,0,0};
PGM_P TCP_Socket_Pointer[10];
PGM_P pointerold;

//TCP Header Layout
#define	TCP_SRCPORT				0x22	//der Quellport fr die Verbindung (Socket)
#define	TCP_DESTPORT			0x24	//der Zielport fr die Verbindung (Socket)
#define	TCP_SEQNUM				0x26	//numerierter Bytestrom
#define	TCP_ACKNUM				0x2A	//numerierter Bytestrom (Gegenrichtung)
#define	TCP_HDRFLAGS			0x2E	//4Bit Lnge des Headers in 32 Bit schritten rest Flags
#define	TCP_WINDOW				0x30	//Fenstergre max. 64K Byte
#define	TCP_CHKSUM				0x32	//Enthlt eine Prfsumme ber Header und Datenbereich
#define	TCP_URGENTPTR			0x34	//16 Bit fr dringende bertragung
#define TCP_DATA				0x36	//Ab hier beginnt der Datenbereich

//TCP Flags
#define  FIN_FLAG				0x01	//Datenbertragung beendet (finished)
#define  SYN_FLAG				0x02	//Verbindungs aufbauen (synchronize)
#define  RST_FLAG				0x04	//Verbindung neu initialisieren (reset)
#define  PSH_FLAG				0x08	//Datenbergabe an Anwendung beschleunigen (push)
#define  ACK_FLAG				0x10	//Datenbertragung besttigen (acknowledged)

