//*******************************************************************************
//* Dieses Programm wurde von Ulrich Radig fr Atmel AVR C geschrieben  		*
//* 																			*
//* Ich wnsche jeden viel Spa mit diesen kleinen Web-Server der ohne 			*
//* zustzlichen Speicher auskommt.												*
//*																				*
//* Bei Fragen und Verbesserungen wendet euch per EMail an						*
//*																				*
//* mail@ulrichradig.de															*
//*																				*
//* oder im Forum meiner Web Page : www.ulrichradig.de							*
//*																				*
//*******************************************************************************

//Prototype
void telnet (char* ,int *);

PROGMEM char telnet_OK[] = {0x00,'%','E','N','D'};
unsigned char cmd[20];
unsigned char cmd_Counter = 0;

void telnet (char* buffer,int *bufferlen)
{
	if (TCP_OPEN(buffer,bufferlen)==1)
		{
		printf("Connection to Telnet Server Open\n");
		return;
		}
		
	unsigned int result16;
	if ((buffer[TCP_HDRFLAGS+1]&PSH_FLAG) > 0 )
		{
		//Errechnet startpunkt der Daten im Tcp buffer
		//IP Headerlnge + TCP Headerlnge + Ethernetframe
		result16 = ((buffer[IP_VERS_LEN] & 0x0F) << 2) + ((buffer[TCP_HDRFLAGS] & 0xF0) >>2) + 14;		
		//Ausgabe des empfangenen Zeichens
		cmd[cmd_Counter] = buffer[result16];
		cmd_Counter++;
		if (buffer[result16]==0x0d)
			{
			cmd_Counter = 0;
			for (int a=0;a < 20;a++)
				{
				if ( cmd[a] == 0x0d){break;}
				printf("%c",cmd[a]);
				}
			printf("\n");
			};
			
		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);				
			
		tcp_add_data (telnet_OK,buffer,bufferlen);
			
		buffer[TCP_HDRFLAGS+1] = ACK_FLAG;
		//Erzeugt ein TCP buffer 
		tcp_make(buffer);			
		//Sendet das erzeugte TCP buffer 
		Write_Ethernet_Frame (buffer,*bufferlen);
		}
	return;
}
